function fxi = evaluate(f,xi);

% function fxi = evaluate(f,xi);
% f is data matrix of form [x , f(x)]
% performs feval if f is a string
% and linear interp if a data matrix
% or linear exptrapolation of xi is out of data range

%xi = xi(:);
[Mx,Nx] = size(xi);
if isstr(f)==1
   fxi = feval(f,xi);
else
   [Mf ,Nf ] = size(f);
   [val,Ia,Ib] = union(f(:,1),f(:,1));
   if (Mf==1); % special case  need to augment array
      f = [f(:,1),f(:,2);f(:,1)+1,f(:,2)];
   end
   if (Mf > length(Ib))
      f = f(sort(Ib),:);
   end
     
   fxi = interp1(f(:,1),f(:,2),xi);
   if norm(isnan(fxi(:)),inf) == 1 & norm(isnan(xi(:)),inf) ~= 1 ; 
      fxi = interp1(f(:,1),f(:,2),xi,'linear','extrap');
   end
end
%fxi = fxi(:);

