%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% BEGIN Parameter section %%
% Grid 
Xmin = 0;                    
Xmax = 1;
Xstep = 51;                   % # of space cells (can be used to ...
			      % improve the accuracy of space integral)
%RefineT = 100;                 % value for grid refinement in time integral
                             % should be less than Tstep
% Iteration control
Win_t = 60;                   % min time node jump in forward solve
Win_x = 10;                     % sets approx # of x-values in mask
Maxit = 2;                    % max # of iterations per level 
Tol = 1e-4;                    % error tolerance in solve (for Delta C and K)
%Tol = 1;                    % error tolerance in solve (for Delta C and K)
%Tol = inf;                    % error tolerance in solve (for Delta C and K)
% Tol for solvers is default 1e-6
% EXPERIMENT parameters
Cmin = 1e-1;                       % lower bound for C(u) 
Cmax = 1e+1;                      % upper bound for C(u)
Ccap = 1;                        % Bound on dC not curently used

Kmin = 1e-0;                       % lower bound for K(u) 
Kmax = 1e+1;                      % upper bound for K(u)
Kcap = 1;                        % Bound on dK not curently used

% Identity parameters
G_const = 1;                   % Const  dual data flux at x = 0
H_const = -2;                   % Const dual data state at x = 1
Zeta1 = 1;                     % Weight for dual g data (g->G_const) (0->1)
Zeta2 = 1;                     % Weight for dual h data (0--1)  
relaxC = 1;                     % relaxation in update of C
relaxK = 1;                     % relaxation in update of K 

% Name of problems
Udot = 'Richv';
Phidot = 'dualdot';
% Solvers to use 
Solver1 = 'ode15s';             % solver - experiment
Solver2 = 'ode15s';             % solver - forward problem
Solver3 = 'ode15s';             % solver - dual problem(s)

plots = 0;                      % turn on plot feature

% END parameter section
%%%%%%%%%%%%%%%%%%%%%%
