function  [sol,tspan,u0] = solve_forward(Solver,Udot,tspan,u0,C,K,BCs,min_x,min_w);

global XXX

options = odeset('Events',@compare,'Mass',@mass,'RelTol',1e-5,'AbsTol',1e-10,'MStateDependence','strong');

%options = odeset('Events',@compare,'Mass',@mass,'RelTol',1e-5,'AbsTol',1e-10,'Vectorized','on','MStateDependence','strong');

p1 = min_x;
p2 = u0(1);	
ts = min(tspan);
p3 = min_w;

%p3 = ts + min_w; % ensures at least n data points in region
pts = [p1,p2,p3];

flag = [];

% forces u0 to be nonpositive
%u0 = min(u0(1:end),0);

sol = feval(Solver,str2func(Udot),tspan,u0,options,C,K,BCs,pts);


%flag = 0;
%if isfield(sol,'xe');
%   tf = sol.xe;
%   u0 = sol.ye;
%else
%   tf = max(tspan);
%   u0 = [];
%   flag = 1;
%end

if isempty(sol.xe);
%  fprintf('Last interval, [%0.2g %0.2g], is too small.\n',min(tspan),max(tspan));
  tf = max(tspan);
  flag = 1;
else 
  tf = sol.xe;  
  flag = 0;
  u0 = sol.ye;
end;
 
tspan = [ts,tf];

%------------------------------

function [value,isterminal,direction] = compare(t,u,C,K,BCs,pts)

value1 = (pts(2)+eps) - u(pts(1));
value2 = t - pts(3);
value3 = (value1>0) + (value2>0) - 2 ;

value = value2; 

isterminal =  1 ;
direction =  1;

%---------------------------------

function out = mass(t,u,C,K,BCs,pts)

d = evaluate(C,u);
out = sparse(diag(d));
