%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% BEGIN Parameter section %%
% Grid 
Xstep = 51;                   % # of space cells (can be used to ...
               			      % improve the accuracy of space integral)

% Iteration control
MaxIt = 4;                    % max # of iterations per level 
Time_w = [ .9 , 1];
%State_w =[ -0.8 , -1 ];
%sindx = 1;                  % uses 1 = time vector 2 = state vector
Tol = 1e-4;                    % error tolerance in drel 
%Tol = 1e-4;                    % error tolerance in solve (for Delta C and K)
%Tol = 1;                    % error tolerance in solve (for Delta C and K)
%Tol = inf;                    % error tolerance in solve (for Delta C and K)
% Tol for solvers is default 1e-6
% EXPERIMENT parameters
bp = -2;                     % bubbling pressure
Cmin = 1e-1;                       % lower bound for C(u) 
Cmax = 1e+1;                      % upper bound for C(u)
Ccap = 1;                        % Bound on dC not curently used
CPmax = 1 ;                    % Lipschitz constant

Kmin = 1e-1;                       % lower bound for K(u) 
Kmax = 1e+1;                      % upper bound for K(u)
Kcap = 1;                        % Bound on dK not curently used
KPmax = 1;                    % Lipschitz constant

% Identity parameters
P_const = 1;                   % Const  dual data state at x = 0 (Gamma)
Q_const = -2;                   % Const dual data flux at x = 1
Zeta1 = 1;                     % Weight for dual p data (g->G_const) (0->1)
Zeta2 = 1;                     % Weight for dual q data (0--1)  
relaxC = 1;                     % relaxation in update of C
relaxK = 1;                     % relaxation in update of K 

% Name of problems
Udot = 'Richv';
Phidot = 'dualdot';
% Solvers to use 
Solver2 = 'ode15s';             % solver - forward problem
Solver3 = 'ode15s';             % solver - dual problem(s)

plots = 0;                      % turn on plot feature

% END parameter section
%%%%%%%%%%%%%%%%%%%%%%
