addpath /home/grad/a/thelwell/re/porous/code/implicit/two/locked
addpath Z://re/porous/code/implicit/two/locked

BC = [0 1 0 ; 1 1 0];
% uses known boundary conditions

scale = linspace(0,1,5);
num = 11;

dataname = sprintf('p%i.dat',num);
tic
for i = 1:5
    Zeta1 = scale(i);
    for j = 1:5
        Zeta2 = scale(j);
        for k = 1:4
            P_const = 10^(k-1); 
            for l = 1:4 
                Q_const = -1*10^(l-1);
                input = [Zeta1,Zeta2,P_const,Q_const]
                
                [delp,delq,c_tspan,drel,app_K,app_C,MM,BB,flg]= ...
                    test_data(dataname,input,BC);
                
                total_err(i,j,k,l) = min(drel);
                
                fname = sprintf('test2_data_p%i_%i_%i_%i_%i',num,i,j,k,l); 
                save(strcat(pwd,filesep,'runs',filesep,fname),...
                    'delp','delq','c_tspan','drel','app_K','app_C','MM','BB','flg','total_err');
                
                clear del* c_tspan drel app* MM BB flg
            end           
        end
    end
end
toc
fix(clock)
rmpath /home/grad/a/thelwell/re/porous/code/implicit/two/locked
rmpath Z://re/porous/code/implicit/two/locked

