function [DP,DQ,C_TSPAN,drel,app_K,app_C,MM,BB,success] = temp(dataname,input,BCs);

% to test dual data 
Zeta1 = input(1);
Zeta2 = input(2);
P_const = input(3);
Q_const = input(4);

%uses state/time breaks 

% Tue Mar  9 09:33:05 MST 2004

%---------------------

global XXX TTT

%--------------------- load data

full_data = load(strcat(pwd,filesep,'data',filesep,dataname));

% script to load all the data

C0 = full_data(1);
K0 = full_data(2);
Xmin = full_data(1,end);
Xmax = full_data(2,end);

data = full_data(3:end,:);

% uses passed BCs if available   
if nargin < 3
  BCs = data(:,1:3);
end

te = data(:,1);
mp = data(:,4);
mq = data(:,5);
ex_data = [ te , mp , mq ];

% ------------------- read parameters

parameter;

%--------------------
%build space grid
x = linspace(Xmin,Xmax,Xstep);       % x grid arbitrary
XXX = x;                             % Triple Caps are global
dt = min(diff(te));

init_C = [ 0 , C0 ];     %  This is presumed to be known
init_K = [ 0 , K0];

app_C = [  init_C ;
    bp-1 , C0 ] ;     % approx_C is the form [ u , D(u) ]
app_K = [  init_K ;
    bp-1 , K0 ] ;     % approx_K is the form [ u , D(u) ]

t = linspace(min(te),max(te));  %current tgrid, will quickly change

strip = 1;  % count of strips
level = 1; % index of current strip
iter = 1; % iteration count on level

limflag = 0;

Tmax = max(t);  %     just to get loop started
ts = min(t);

u0 = 0*XXX(2:end-1)';  %initial condition
U0{level,iter} = u0;
% Continue while in experimental time interval

while( strip == 1)
disp('Special solve only on first strip');

% -------------------- 
%while( ts<Tmax )
    %solve direct problem in current strip
% -------------------- 
    
    off_diag_entries = 0;
     
    while (level <= strip)
        tspan_0 = [ts,Tmax];
        [sol, tspan, ufinal] = solve_forward(Solver2, Udot, tspan_0,...
            u0,app_C,app_K,BCs,...
            Time_w,State_w,sindx,level);  
        
        % initialize for next time strip;
        ts = max(tspan);
        %begin to construct nodes and values of numerical solution
        % that coincide with experimental data
        [c_nodes,c_tspan] = find_nodes(te,tspan);
        [c_tspan,c_u,c_p,c_q] = make_data(sol,c_tspan,app_K,BCs);
        mmp = trapz(c_tspan,mq(c_nodes));
        mmq = trapz(c_tspan,mp(c_nodes));
        dp = mp(c_nodes) - c_p;   %delta p
        dq = mq(c_nodes) - c_q;   %delta q
        % compute relatative error measure (relative L^1 norm)
        drel(level,iter) = abs(trapz(c_tspan,dp)/mmp) + abs(trapz(c_tspan,dq)/mmq); 
        
        u0 = ufinal;
        % store some of these values
        % for double integral (M)
        SOL{level,iter} = sol;
        U0{level+1,iter} = ufinal;
        TSPAN{level,iter}= tspan;
        
        % for data integrals (b)
        C_TSPAN{level,iter} = c_tspan;
        DP{level,iter} = dp;
        DQ{level,iter} = dq;
        level = level+1;
    end   % end while loop ( direct problem is finished)
    
    level = level - 1;
    tfinal{iter} = ts;
    
    for i = strip   %loop for dual problem
        phi0.one = 0 * XXX(2:end-1)';
        phi0.two = phi0.one;
        %disp('Fix dual_K and dual_kp here')
        dual_kp = 0;  % check this 
        %dual_K = 1+(0)*XXX'; % check this 
        dual_K = mean(app_K(:,2));
        %dual_K = app_k;
        theta.one = [C_TSPAN{i,iter} , ...
         (1-Zeta1)*DP{i,iter}(end:-1:1) + Zeta1*(P_const+0*DP{i,iter}),...
                         0*DQ{i,iter}];
        theta.two = [C_TSPAN{i,iter} , ...
                      0*DP{i,iter},...
			 (1-Zeta2)*DQ{i,iter}(end:-1:1) + Zeta2*(Q_const+0*DQ{i,iter})];
        dual= solve_dual(Solver3,Phidot,TSPAN{i,iter},phi0,app_C,dual_K,dual_kp,theta);
        DUALSOL{i,iter} = dual;
    end
    col2 = [];   
    
    %    for i = 1:iter
    for i = strip
        index = find(SOL{i,iter}.x<max(TSPAN{i,iter}));
        common_t = union(TSPAN{i,iter},SOL{i,iter}.x(index));
        common_tau = min(common_t) + max(common_t) - common_t;
        common_tau(1) = common_t(end);
        common_tau(end) = common_t(1);
        u = deval(SOL{i,iter},common_t); 
        phi = deval(DUALSOL{i,iter}.one,common_tau);
        save junk
        psi = deval(DUALSOL{i,iter}.two,common_tau);
        u = fix_b(u,common_t,BCs);
        phi = fix_b(phi,common_tau,theta.one);
        psi = fix_b(psi,common_tau,theta.two);
        T{i} = common_t;U{i,iter} = u;PHI{i,iter} = phi;PSI{i,iter} = psi;
        % fix bcs u phi and psi
        [ut,ux] = gradient(u,common_t,XXX);
        [phit,phix] = gradient(phi,common_t,XXX); 
        [psit,psix] = gradient(psi,common_t,XXX);
        col1(i) = min([u(1,:),u(end,:)]);
        loweru = col1(i);
        if (i == 1)
            upperu = max(max(u));
        else
            upperu = col1(i-1);
        end
        mask = ( u >= loweru | u < upperu );
        lam = (u - upperu)./ (loweru - upperu);
        MASK{i} = mask;LAM{i} = lam;
        PHIX{i} = phix;PSIX{i} = psix;PHIT{i} = phit;PSIT{i} = psit;
        M(1,1) = integrate(mask.*lam.*(ux-1).*phix,common_t,XXX);
        M(1,2) = integrate(mask.*lam.*ut.*phi,common_t,XXX);
        M(2,1) = integrate(mask.*lam.*(ux-1).*psix,common_t,XXX);
        M(2,2) = integrate(mask.*lam.*ut.*psi,common_t,XXX);
        Pstar =  myinterp1(theta.one(:,1:2),C_TSPAN{i,iter});
        Qstar =  myinterp1(theta.two(:,1:2:3),C_TSPAN{i,iter});
        fprintf('\nUsing %i data points.\n',length(C_TSPAN{i,iter}));
        if length(C_TSPAN{i,iter})<4  %uses at least four points for integral
            b(1,1) = 0;b(2,1) = 0;
        else
            b(1,1) = trapz(C_TSPAN{i,iter},DP{i,iter}.*Pstar);
            b(2,1) = trapz(C_TSPAN{i,iter},DQ{i,iter}.*Qstar);
        end
        MM{i,iter} = M; BB{i,iter} = b;
        col2 = [];
        col2(2*i-1:2*i,1) = M \b;
    end
    
    oldK = myinterp1(app_K,col1);
    oldC = myinterp1(app_C,col1);
    dK = col2(1:2:end);

    dC = col2(2:2:end);

    app_K = [];
    app_C = [];
    app_K = [ init_K;
        col1' , oldK'+dK];
    app_K = [app_K ; 
        app_K(end,1)*1.01, app_K(end,2)];
    app_K(:,2) = max(app_K(:,2),Kmin); %limit update
    app_C = [ init_C;
        col1' , oldC'+dC];
    app_C = [app_C ; 
        app_C(end,1)*1.01, app_C(end,2)];
    app_C(:,2) = max(app_C(:,2),Cmin);
    
    app_K
    app_C
    
    dKKK{strip,iter} = dK;
    dCCC{strip,iter} = dC;
    CCC{strip,iter} = app_C;
    KKK{strip,iter} = app_K;
    %     if norm(dK>0,inf) > 0
    %        dK;
    %        fprintf('Do nothing');
    %        dK = (dK<=0).*dK;   % limit dK to be monotone 
    %        fprintf('limiting dK update and iterating');
    %        itflag = 1;
    %      end
    
    if (min(app_C(:,2)) == Cmin) | (min(app_K(:,2)) == Kmin)
        disp('Limited coefficient.  But continue.');
        %keyboard
        limflag = limflag + 1;
        special_lim_flag = 1;
    end
    
    % Check for advancement conditions
 
   error = drel(level,iter);
   
   if iter < MaxIt
       if drel(level,iter) > Tol
           iter = iter+1; %advance iteration count
           fprintf('Iteration %i on strip %i.\n',iter-1,strip);
           fprintf('L^1 error = %6.4e > %6.5e = Tol \n',error,Tol); 
           ts = min(TSPAN{level,iter-1});
           u0 = U0{level,1};
       else
           success(strip) = 1;
           fprintf('Reached tolerance at iteration %i on strip %i.\n',iter-1,strip); 
           fprintf('L^1 error = %6.4e <= %6.5e = Tol \n',error,Tol); 
           u0 = U0{level+1,iter};
           ts = tfinal{iter};
           strip = strip + 1;
           level = strip - off_diag_entries;
           iter = 1;
       end
   else %failed to reach tolerece in maxits
       disp('Failed to reach Tol in MaxIts. Using best approx.');
       success(strip) = 0;
       [best_val,best_indx] = min(drel(level,:));
       fprintf('L^1 error = %6.4e > %6.5e = Tol \n',best_val,Tol);
       u0 = U0{level+1,best_indx};
       ts = tfinal{best_indx};
       app_C = CCC{strip,best_indx};
       app_K = KKK{strip,best_indx};
       strip = strip+1;
       level = strip - off_diag_entries;
       iter = 1;
   end
end
 
