paramtable ={
'\alpha = 1/3 \beta = 2',
'\alpha = 1/2 \beta = 2',
'\alpha = 1 \beta = 2',
'\alpha = 2 \beta = 2',
'\alpha = 3 \beta = 2',
'\alpha = 1 \beta = 0',
'\alpha = 1 \beta = 1',
'\alpha = 1 \beta = 2',
'\alpha = 1 \beta = 3',
'\alpha = 1 \beta = 4',
'\alpha = 1 \beta = 5',
'C(h) = 1 , K(h) = 1+sin(5h)',
'C(h) = 1+sin(5h) , K(h) = 1',
};

table = {
{1, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{2, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{4, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{5, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 1, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 2, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 3, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 4, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 5, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{3, 6, 1 , 'ode15s' , 101 , 1 , 51, [0,0,0,0]},
{6, 8},
{7, 7},
};

for i = 1:13
   fname = sprintf('p%i.dat',i);
   name = fname(1:end-3);
   data = load(fname);
   tl = data(3:end,1);
   pl = data(3:end,4);
   ql = data(3:end,5);
   x_indx = find(abs(pl-ql)<1e-3);
   x_val(i) = p(x_indx(1))
   data = data(3:5:end,:);
   t = data(:,1);
   p = data(:,4);
   q = data(:,5);
   pspan = linspace(min(p),0);
   truC = C(pspan,table{i}{1});
   truK = K(pspan,table{i}{2});
   truCs = C(p,table{i}{1});
   truKs = K(p,table{i}{2});
   figure;
   subplot(2,1,1);
   plot(t,p,'k<',t,q,'k>',tl,pl,'-k',tl,ql,'-k');
   axis([0,3,-1.5 , 0.1]);
   h = legend('p','q',-1);
   set(h,'FontSize',18');
   xlabel('t','FontSize',18);
   ylabel('p(t) and q(t)','FontSize',18);
   title('Data p(t) and q(t)','FontSize',20);
   subplot(2,1,2);
   plot(pspan,truC,'k--',pspan,truK,'k-',...
             p,truCs,'kx',...
             p,truKs,'kx');
   axis([min(p),0,0,2]);
   h = legend('C','K',-1);
   set(h,'FontSize',18');
   xlabel('h','FontSize',18);
   ylabel('C(h) and K(h)','FontSize',18);
   title(paramtable{i},'FontSize',20);
%   print('-deps',strcat(name,'eps'));
end

